#include <Rcpp.h>
using namespace Rcpp;

// [[Rcpp::export]]
NumericMatrix fastdist2(NumericMatrix x, NumericMatrix y, int b) {
  int N = x.nrow(), M = y.nrow();
  NumericMatrix res(N,M);

  for(int i=0; i<N; i++){
    int st=i-b;
    if( st<0 ){
      st=0;
    }
    int ed = i+b+1;
    if(ed>M){
      ed=M;
    }
    for(int j=st; j < ed; j++){
      res(i,j) = sum((x(i,_)-y(j,_))*(x(i,_)-y(j,_)));
    }
  }
  return res;
}
